=== src/base/hip/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2018-2023 Advanced Micro Devices, Inc. All rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# ########################################################################

set(HIP_SOURCES
  base/hip/hip_conversion.cpp
  base/hip/hip_blas.cpp
  base/hip/hip_sparse.cpp
  base/hip/backend_hip.cpp
  base/hip/hip_allocate_free.cpp
  base/hip/hip_vector.cpp
  base/hip/hip_matrix_csr.cpp
  base/hip/hip_matrix_coo.cpp
  base/hip/hip_matrix_dense.cpp
  base/hip/hip_matrix_mcsr.cpp
  base/hip/hip_matrix_bcsr.cpp
  base/hip/hip_matrix_ell.cpp
  base/hip/hip_matrix_dia.cpp
  base/hip/hip_matrix_hyb.cpp
  base/hip/hip_rsamg_csr.cpp
)
