=== debian/changelog ===
rocalution (7.1.0-0ubuntu2) resolute; urgency=medium

  * d/shlibs: update SONAME version
  * d/rules: skip local_vector_test.extract_coarse_mapping_int on arm64
  * d/rules: fix execute_after_dh_auto_build-indep envvars

 -- Bruno Bernardo de Moura <bruno.moura@canonical.com>  Tue, 03 Feb 2026 16:40:38 -0300

rocalution (7.1.0-0ubuntu1) resolute; urgency=medium

  * New upstream release 7.1.0.
  * d/p/series: drop outdated and unused patches for 7.1.0
    - drop d/p/spelling.patch
    - drop d/p/use-readthedocs-theme.patch
    - drop d/p/docs-table-of-contents.patch
    - drop d/p/use-local-mathjax.patch.
    - drop d/p/fix-host-and-backend-function-documentation.patch
  * d/control: update standards version to 4.7.2
  * d/control: update maintainer field for ubuntu archive
  * d/control: update build-depends for rocm stack
  * d/control: update SOVERSION (0 -> 1) after API changes
  * d/rules: fix docs build step with rocm-docs-build
  * d/rules: fix lintian warnings and improve docs cleanup
  * d/{librocalution-doc.doc-base,librocalution-doc.docs}:
    fix doc generation paths
  * d/shlibs: drop auto generated file
  * d/{t/control,librocalution0-tests.install}:
    update test files SOVERSION (0 -> 1)
  * d/librocalution1.symbols: add symbols file for 7.1.0

 -- Bruno Bernardo de Moura <bruno.moura@canonical.com>  Wed, 10 Dec 2025 14:27:06 -0300

rocalution (5.7.1-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 29 Jan 2026 21:42:09 +0100
