=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocalution1-tests
Depends: librocalution1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
